package eu.jonahbauer.json.tokenizer.token;

import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.experimental.Accessors;
import org.jetbrains.annotations.NotNull;

@Getter
@Accessors(fluent = true)
@RequiredArgsConstructor
public enum JsonPunctuation implements JsonToken {
    BEGIN_OBJECT('{'),
    END_OBJECT('}'),
    BEGIN_ARRAY('['),
    END_ARRAY(']'),
    VALUE_SEPARATOR(','),
    NAME_SEPARATOR(':'),
    ;

    private final char value;

    @Override
    public @NotNull String toString() {
        return name() + "(" + value + ")";
    }
}
