package eu.jonahbauer.json.query;

import eu.jonahbauer.json.JsonString;
import eu.jonahbauer.json.JsonValue;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

@Getter
public class JsonQueryHaltException extends JsonQueryException {
    private final @Nullable JsonValue value;
    private final int statusCode;

    public JsonQueryHaltException(@Nullable JsonValue value, int statusCode) {
        super(getMessage(value));
        this.value = value;
        this.statusCode = statusCode;
    }

    private static @NotNull String getMessage(@Nullable JsonValue value) {
        return switch (value) {
            case JsonString(var string) -> string;
            case null -> "";
            default -> JsonValue.toJsonString(value);
        };
    }
}
