package eu.jonahbauer.json.query;

import lombok.Getter;
import org.jetbrains.annotations.NotNull;

@Getter
public class JsonQueryParserException extends JsonQueryException {
    private final int line;
    private final int column;

    public JsonQueryParserException(int line, int column, @NotNull String message) {
        super(message);
        if (line < 0 || column < 0) throw new IllegalArgumentException();

        this.line = line;
        this.column = column;
    }

    public JsonQueryParserException(int line, int column, @NotNull String message, @NotNull Throwable cause) {
        this(line, column, message);
        initCause(cause);
    }

    @Override
    public @NotNull String getMessage() {
        return STR."\{super.getMessage()} at line \{line}, column \{column}";
    }
}
