package eu.jonahbauer.json.query;

import eu.jonahbauer.json.JsonString;
import eu.jonahbauer.json.JsonValue;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;

@Getter
public class JsonQueryUserException extends JsonQueryException {
    private final @NotNull JsonValue value;

    public JsonQueryUserException(@NotNull JsonValue value) {
        super(getMessage(value));
        this.value = value;
    }

    private static @NotNull String getMessage(@NotNull JsonValue value) {
        return switch (value) {
            case JsonString(var string) -> string;
            case JsonValue v -> "(not a string): " + v.toJsonString();
        };
    }
}
