package eu.jonahbauer.json.query.impl;

import org.jetbrains.annotations.NotNull;

import java.util.Objects;
import java.util.function.Function;

final class MappingGenerator<T, S> implements Generator<S> {
    private final @NotNull Generator<T> delegate;
    private final @NotNull Function<? super T, ? extends S> function;

    public MappingGenerator(@NotNull Generator<T> delegate, @NotNull Function<? super T, ? extends S> function) {
        this.delegate = Objects.requireNonNull(delegate);
        this.function = Objects.requireNonNull(function);
    }

    @Override
    public boolean hasNext() {
        return delegate.hasNext();
    }

    @Override
    public S next() {
        return function.apply(delegate.next());
    }
}
