package eu.jonahbauer.json.query.impl;

import java.util.NoSuchElementException;

final class SingletonGenerator<T> implements Generator<T> {
    private boolean done;
    private T value;

    public SingletonGenerator(T value) {
        this.value = value;
    }

    @Override
    public boolean hasNext() {
        return !done;
    }

    @Override
    public T next() {
        if (done) throw new NoSuchElementException();

        var out = value;
        done = true;
        value = null;
        return out;
    }
}
