package eu.jonahbauer.json.query.impl;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.NoSuchElementException;
import java.util.Objects;
import java.util.function.Supplier;

final class SupplierGenerator<T> implements Generator<T> {
    private @Nullable Supplier<? extends T> value;

    public SupplierGenerator(@NotNull Supplier<? extends T> supplier) {
        this.value = Objects.requireNonNull(supplier);
    }

    @Override
    public boolean hasNext() {
        return value != null;
    }

    @Override
    public T next() {
        if (value != null) {
            var out = value.get();
            value = null;
            return out;
        }
        throw new NoSuchElementException();
    }
}
