package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonArray;
import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;

public record JQArrayConstructionExpression(@NotNull JQExpression expression) implements JQExpression {
    public JQArrayConstructionExpression {
        Objects.requireNonNull(expression);
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return Generator.of(() -> new JsonArray(expression.evaluate(context).toList()));
    }

    @Override
    public boolean isConstant() {
        return expression.isConstant();
    }

    @Override
    public @NotNull String toString() {
        return "[" + expression + "]";
    }
}
