package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public record JQConstant(@Nullable JsonValue value) implements JQExpression {

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return Generator.of(value);
    }

    @Override
    public boolean isConstant() {
        return true;
    }

    @Override
    public @NotNull String toString() {
        return JsonValue.toJsonString(value);
    }
}
