package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.JsonMath;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;

public record JQIterateExpression(@NotNull JQExpression expression, boolean optional) implements JQExpression {
    public JQIterateExpression {
        Objects.requireNonNull(expression);
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return expression.evaluate(context).flatMap(value -> JsonMath.values(value, optional));
    }

    @Override
    public boolean isConstant() {
        return expression.isConstant();
    }

    @Override
    public @NotNull String toString() {
        return expression + "[]" + (optional ? "?" : "");
    }
}
