package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.JsonMath;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;
import java.util.stream.Stream;

public record JQNegation(@NotNull JQExpression expression) implements JQExpression {
    public JQNegation {
        Objects.requireNonNull(expression);
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return expression.evaluate(context).map(JsonMath::neg);
    }

    @Override
    public boolean isConstant() {
        return expression.isConstant();
    }

    @Override
    public @NotNull String toString() {
        return "-" + expression;
    }
}
