package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;

public record JQParenthesizedExpression(@NotNull JQExpression expression) implements JQExpression {

    public JQParenthesizedExpression {
        Objects.requireNonNull(expression);
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return expression.evaluate(context);
    }

    @Override
    public boolean isConstant() {
        return expression.isConstant();
    }

    @Override
    public @NotNull String toString() {
        return "(" + expression + ")";
    }
}
