package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;
import java.util.stream.Stream;

public record JQPipeExpression(@NotNull JQExpression first, @NotNull JQExpression second) implements JQExpression {
    public JQPipeExpression {
        Objects.requireNonNull(first);
        Objects.requireNonNull(second);
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return first.evaluate(context).flatMap(value -> second.evaluate(context.withRoot(value)));
    }

    @Override
    public boolean isConstant() {
        return first.isConstant() && second.isConstant();
    }

    @Override
    public @NotNull String toString() {
        return first + " | " + second;
    }
}
