package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

public record JQProgram(
        @Nullable JQModule module,
        @NotNull List<@NotNull JQImport> imports,
        @NotNull List<@NotNull JQFunction> functions,
        @Nullable JQExpression expression
) {
    public @NotNull Generator<@Nullable JsonValue> run(@Nullable JsonValue value) {
        if (expression == null) return Generator.empty();
        return expression.evaluate(new JQExpression.Context(value).withFunctions(functions));
    }
}
