package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import eu.jonahbauer.json.query.impl.Generator;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;

public record JQVariableExpression(@NotNull String name) implements JQExpression {
    public JQVariableExpression {
        Objects.requireNonNull(name);
        if (!name.startsWith("$")) throw new IllegalArgumentException();
    }

    @Override
    public @NotNull Generator<@Nullable JsonValue> evaluate(@NotNull Context context) {
        return Generator.of(() -> context.variable(name));
    }

    @Override
    public boolean isConstant() {
        return false;
    }

    @Override
    public @NotNull String toString() {
        return name;
    }
}
