package eu.jonahbauer.json.query.parser.tokenizer;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;

public record JQToken(
        @NotNull JQTokenKind kind, @NotNull String text,
        @Nullable Double nval, @Nullable String sval,
        int line, int column
) {
    public JQToken(@NotNull JQTokenKind kind, @NotNull String text, int line, int column) {
        this(kind, text, null, null, line, column);
    }

    public JQToken(@NotNull JQTokenKind kind, @NotNull String text, @NotNull Double nval, int line, int column) {
        this(kind, text, nval, null, line, column);
    }

    public JQToken(@NotNull JQTokenKind kind, @NotNull String text, @NotNull String sval, int line, int column) {
        this(kind, text, null, sval, line, column);
    }

    @Override
    public @NotNull String toString() {
        if (kind.isDynamic()) {
            return kind + "(" + text + ")";
        } else {
            return kind.toString();
        }
    }
}
