package eu.jonahbauer.json.query.parser.tokenizer;

import lombok.AccessLevel;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public enum JQTokenKind {
    NEQ,
    EQ,
    DEFINEDOR,
    SETPIPE,
    SETPLUS,
    SETMINUS,
    SETMULT,
    SETDIV,
    SETMOD,
    SETDEFINEDOR,
    LESSEQ,
    GREATEREQ,
    REC,
    ALTERNATION,

    // keywords
    AS("as"),
    IMPORT("import"),
    INCLUDE("include"),
    MODULE("module"),
    DEF("def"),
    IF("if"),
    THEN("then"),
    ELSE("else"),
    ELSE_IF("elif"),
    AND("and"),
    OR("or"),
    END("end"),
    REDUCE("reduce"),
    FOREACH("foreach"),
    TRY("try"),
    CATCH("catch"),
    LABEL("label"),
    BREAK("break"),
    LOC("$__loc__"),

    // without name
    DOT("."),
    QUESTION_MARK("?"),
    ASSIGN("="),
    SEMICOLON(";"),
    COMMA(","),
    COLON(":"),
    PIPE("|"),
    PLUS("+"),
    MINUS("-"),
    MULT("*"),
    DIV("/"),
    MOD("%"),
    DOLLAR("$"),
    LESS("<"),
    GREATER(">"),

    LBRACKET("["),
    LBRACE("{"),
    LPAREN("("),

    RBRACKET("]"),
    RBRACE("}"),
    RPAREN(")"),

    QQSTRING_START,
    QQSTRING_TEXT(true),
    QQSTRING_END,
    QQSTRING_INTERP_START,
    QQSTRING_INTERP_END,

    FIELD(true),
    FORMAT(true),
    NUMBER(true),
    IDENT(true),
    ;

    private final @NotNull String name;
    @Getter(AccessLevel.PACKAGE)
    private final boolean dynamic;

    JQTokenKind(@NotNull String name) {
        this.name = "\"" + name + "\"";
        this.dynamic = false;
    }

    JQTokenKind(boolean dynamic) {
        this.name = name();
        this.dynamic = dynamic;
    }

    JQTokenKind() {
        this.name = name();
        this.dynamic = false;
    }

    @Override
    public @NotNull String toString() {
        return name;
    }
}
